   azTestString             EQU  010ch
     ;;;;;;;;;
     ; RESET ;
     ;;;;;;;;;
     A0000:
0000:   ajmp A0024
     ;;;;;;;;
     ; INT0 ;
     ;;;;;;;;
     A0003:
0003:   ajmp A009f
     ;;;;;;;;;;
     ; TIMER0 ;
     ;;;;;;;;;;
     A000b:
000B:   ajmp A0075
     A0013:
0013:   reti
     A001b:
001B:   reti
     A0023:
0023:   reti
     ;;;;;;;;;;;;;;;;;;;;;;;
     ; Start of Reset Code ;
     ;;;;;;;;;;;;;;;;;;;;;;;
     A0024:
0024:   mov SP,#30h
0027:   mov 20h,#00h
002A:   clr 01h
002C:   mov TCON,#00h
002F:   mov IE,#82h
0032:   mov 13h,#10h
0035:   mov R1,#00h
0037:   mov DPTR,#azTestString
     A003a:
003A:   acall A00fb                  ; Print AsciiZ String from Program Memory
003C:   mov A,#3ah
003E:   acall F0054                  ; Send Character from Serial Port ???
0040:   mov A,R1
0041:   acall A00dd
0043:   inc R1
0044:   djnz 13h,A003a
     A0047:
0047:   setb EX0
     A0049:
0049:   jnb 03h,A0049
004C:   clr 03h
004E:   mov A,11h
0050:   acall F0054                  ; Send Character from Serial Port ???
0052:   sjmp A0047
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ; Send Character from Serial Port ??? ;
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     F0054:
0054:   jb 01h,F0054
0057:   acall A005d
     A0059:
0059:   jb 00h,A0059
005C:   ret
     A005d:
005D:   mov 10h,A
005F:   mov 12h,#0ah
0062:   mov TH0,#0ffh
0065:   mov TL0,#75h
0068:   mov TH1,#0ffh
006B:   mov TL1,#75h
006E:   setb TR0
0070:   clr P1.0
0072:   setb 00h
0074:   ret
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ; TIMER0 Interrup Handler ;
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;
     A0075:
0075:   push ACC
0077:   push PSW
0079:   jb 01h,A00ba
007C:   jb 00h,A0086
     B007f:
007F:   clr TR0
     D0081:
0081:   pop PSW
0083:   pop ACC
0085:   reti
     A0086:
0086:   djnz 12h,A008d
0089:   clr 00h
008B:   sjmp B007f
     A008d:
008D:   mov A,12h
008F:   cjne A,#01h,A0096
0092:   setb P1.0
0094:   sjmp D0081
     A0096:
0096:   mov A,10h
0098:   rrc A
0099:   mov 10h,A
009B:   mov P1.0,C
009D:   sjmp D0081
     ;;;;;;;;;;;;;;;;;;;;;;;;;;
     ; INT0 Interrupt Handler ;
     ;;;;;;;;;;;;;;;;;;;;;;;;;;
     A009f:
009F:   mov 12h,#0ah
00A2:   mov TH0,#0ffh
00A5:   mov TL0,#0d9h
00A8:   mov TH1,#0ffh
00AB:   mov TL1,#75h
00AE:   mov 11h,#00h
00B1:   clr EX0
00B3:   clr 02h
00B5:   setb TR0
00B7:   setb 01h
00B9:   reti
     A00ba:
00BA:   djnz 12h,A00ca
00BD:   jb P1.5,A00c2
     A00c0:
00C0:   setb 02h
     A00c2:
00C2:   clr 01h
00C4:   setb EX0
00C6:   setb 03h
00C8:   sjmp B007f
     A00ca:
00CA:   mov A,12h
00CC:   cjne A,#09h,A00d4
00CF:   jb P1.5,A00c0
00D2:   sjmp D0081
     A00d4:
00D4:   mov A,11h
00D6:   mov C,P1.5
00D8:   rrc A
00D9:   mov 11h,A
00DB:   sjmp D0081
     A00dd:
00DD:   push ACC
00DF:   swap A
00E0:   acall B00eb                  ; Convert Nibble in Acc to Hexadecimal Ascii Character
00E2:   acall F0054                  ; Send Character from Serial Port ???
00E4:   pop ACC
00E6:   acall B00eb                  ; Convert Nibble in Acc to Hexadecimal Ascii Character
00E8:   acall F0054                  ; Send Character from Serial Port ???
00EA:   ret
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ; Convert Nibble in Acc to Hexadecimal Ascii Character ;
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     B00eb:
00EB:   anl A,#0fh                   ; mask of lower nibble
00ED:   jnb ACC.3,B00f8              ; branch if 0000..0111 (i.e. '0'..'7')
00F0:   jb ACC.2,A00f6               ; branch if 1100..1111 (i.e. 'c'..'f')
00F3:   jnb ACC.1,B00f8              ; branch if 1000..1001 (i.e. '8'..'9')
     A00f6:
00F6:   add A,#07h                   ; convert 12..15 to 'A'..'F'
     B00f8:
00F8:   add A,#30h                   ; convert 0..9 to ascii
00FA:   ret
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     ; Print AsciiZ String from Program Memory ;
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     A00fb:
00FB:   push ACC
00FD:   mov R0,#00h
     A00ff:
00FF:   mov A,R0
0100:   movc A,@A+DPTR               ; fetch next character from program memory
0101:   cjne A,#00h,A0107            ; branch to print char if not terminating NUL
0104:   pop ACC
0106:   ret
     A0107:
0107:   acall F0054                  ; Send Character from Serial Port ???
0109:   inc R0                       ; increment pointer (offset really!)
010A:   sjmp A00ff                   ; and loop back for the next character
     @010c:
010C:   db	0d,0a,"This is a test of the software RS-232 transmit routine",0

